DefaultHead=TeXHead;

real factor = 0.4;

object OldNode(string l, pair p){
    label(l,p*factor);
    return draw("", ellipse, p*factor, xmargin=3mm,FillDraw(white,black));
}

object NewNode(string l, pair p){
    label(l,p*factor);
    return draw("", ellipse, p*factor, xmargin=3mm,FillDraw(white,black+linewidth(0.5mm)));
}

object a = OldNode("A",(0cm,0cm));
object b = OldNode("B",(-4cm,-5cm));
object c = OldNode("C",(4cm,-5cm));
object d = OldNode("D",(-2cm,-10cm));
object e = OldNode("E",(2cm,-10cm));
object f = OldNode("F",(6cm,-10cm));

object a2 = NewNode("A",(-5cm,0cm));
object b2 = NewNode("B",(-7cm,-5cm));
object g = NewNode("G",(-9cm,-10cm));

pair left(object p){
    return point(p,dir(-120));
}

pair right(object p){
    return point(p,dir(-60));
}

pair top(object p){
    return point(p,dir(90));
}

draw(left(a)--top(b),black,Arrow());
draw(right(a)--top(c),black,Arrow());
draw(left(a2)--top(b2),dashed,Arrow());
draw(right(a2)--top(c),dashed,Arrow());

draw(right(b)--top(d),black,Arrow());
draw(left(b2)--top(g),dashed,Arrow());
draw(right(b2)--top(d),dashed,Arrow());

draw(left(c)--top(e),black,Arrow());
draw(right(c)--top(f),black,Arrow());
