import succinct_common;

pair C = (0,0);
PENTAMIXER_R = 0.75;
pentamixer(C);
pm_arrow(C, A_IN, 1, lbl="\vbox{\hbox{$x\in[X]$}\hbox{\eightrm (input)}}");
pm_arrow(C, A_CIN1, 1, lbl="\vbox{\hbox{$y\in[Y]$}\hbox{\eightrm (carry in 1)}}");
pm_arrow(C, A_CIN2, 1, lbl="\vbox{\hbox{$z\in[Z]$}\hbox{\eightrm (carry in 2)}}");
pm_arrow(C, A_OUT, 1, out=true, lbl="\vbox{\hbox{$m\in[2^M]$}\hbox{\eightrm (output)}}");
pm_arrow(C, A_COUT, 1, out=true, lbl="\vbox{\hbox{$s\in[S]$}\hbox{\eightrm (carry out)}}");

PENTAMIXER_R = 0.5;

pair m1 = (5, -1);
pair m2 = (9, -1);
pair m3 = (7, 1.5);
pair mix[] = {m1, m2, m3};
pentamixer(m1);
pentamixer(m2);
pentamixer(m3);
draw(pm_dir(m1, A_COUT)--pm_dir(m3, A_CIN1), e_arrow);
draw(pm_dir(m2, A_COUT)--pm_dir(m3, A_CIN2), e_arrow);
for (int i = 0; i < 3; ++i) {
    pm_arrow(mix[i], A_IN,  0.5, lbl="in");
    pm_arrow(mix[i], A_OUT, 0.5, out=true, lbl="out");
}
for (int i = 0; i < 2; ++i) {
    pm_arrow(mix[i], A_CIN1,  0.5, "$\vdots$");
    pm_arrow(mix[i], A_CIN2,  0.5, "$\vdots$");
}
pm_arrow(m3, A_COUT, 0.5, out=true, "$\vdots$");
