import succinct_common;

real mixgrid = 2.5;
int nmixers = 3;

for (int i = 0; i < nmixers; ++i) {
    real x = mixgrid * i;
    draw((x, 1.25) -- (x, 0.5), e_arrow);
    label((x, 1.25), "$(B+1)^2$", N);
    mixer(x, 0);
    draw((x, -0.5) -- (x, -1.25), e_arrow);
    label((x, -1.25), "$B^2$", S);
}

string[] alphas = {"B+3", "B+6", "B+9", "B+12"};

for (int i = 0; i < nmixers+1; ++i) {
    carry_arrow((mixgrid * (i-1), 0), (mixgrid*i, 0), alphas[i]);
}
