import ads;

int[] block_indices = {0,0,1,2,4};
real[] block_offs;
real[] block_widths;

real w = 0.4;
real h = 0.4;
real s = 0.1;

real draw_block(real offset, int ypos, int index) {
	real width = 2^index * w;
	draw(box((offset, ypos), (offset+width, ypos+h)), thin);
	return width;
}

string b_i(int i) {
	return "\eightrm $B_" + string(i) + "$";
}

int prev_i = 0;
real offset = -s;
for (int i : block_indices) {
	offset += s;
	if (i == 4) {
		offset += 3*s;
	}
	real width = draw_block(offset, 0, i);
	block_offs.push(offset);
	block_widths.push(width);
	offset += width;
	prev_i = i;
}

for (int i = 0; i < 5; ++i) {
	real x = block_offs[i] + block_widths[i]/2;
	string name;
	if (i > 0)
		name = b_i(block_indices[i]);
	else
		name = "$x$";
	label(name, (x, h/2));
	draw((x, -0.1) -- (x, -1+h+0.1), thin, e_arrow);
}
real width = draw_block(0, -1, 3);
label(b_i(3), (width/2, h/2 - 1));
real width2 = draw_block(block_offs[4], -1, 4);
label(b_i(4), (block_offs[4] + block_widths[4]/2, h/2 - 1));
