import succinct_common;

void fillbox(int col, pen pen) {
    path p = (
        (col*blockwidth, -rowheight-blockheight)
        -- ((col+2)*blockwidth, -rowheight-blockheight)
        -- ((col+2)*blockwidth, -2*rowheight)
        -- ((col+1)*blockwidth, -2*rowheight)
        -- ((col+1)*blockwidth, -3*rowheight)
        -- ((col-1)*blockwidth, -3*rowheight)
        -- ((col-1)*blockwidth, -2*rowheight-blockheight)
        -- ((col)*blockwidth, -2*rowheight-blockheight)
        -- cycle
        );
    fill(p, pen);
    draw(p, thick);
}

fillbox(2, 0.5*white);
fillbox(4, 0.75*white);
fillbox(6, 0.5*white);

//blocks(0 ... concat(array(8,"B"), new string[] {"..."}));
//thruarrows(0,0,6);
blocks(1 ... concat(array(8, "B+1"), array(1, "...")) );
mixarrows(1,0,8);
blocks(2,  "B", "B+3", "B-3", "B+6", "B-6", "B+9", "B-9", "...");
thruarrow(2, 0);
mixarrows(2, 1, 6);
blocks(3 ... concat(array(7,"B"), array(1, "...")));
